<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "listing_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ListingType".
 *
 * Columns in table "listing_type" available as properties of the model,
 * followed by relations of table "listing_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $level
 * @property integer $is_internal
 * @property string $code
 * @property string $per
 * @property string $logo_path
 * @property string $base_url
 *
 * @property PartnerSite[] $partnerSites
 * @property ProviderPracticeListing[] $providerPracticeListings
 * @property ProviderPracticeSocialEnhance[] $providerPracticeSocialEnhances
 */
abstract class BaseListingType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'listing_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ListingType|ListingTypes', $n);
    }

    public static function representingColumn()
    {
        return 'code';
    }

    public function rules()
    {
        return array(
            array('code', 'required'),
            array('is_internal', 'numerical', 'integerOnly' => true),
            array('level', 'length', 'max' => 8),
            array('code', 'length', 'max' => 80),
            array('per', 'length', 'max' => 1),
            array('logo_path, base_url', 'length', 'max' => 255),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, level, is_internal, code, per, sort_order', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'partnerSites' => array(self::HAS_MANY, 'PartnerSite', 'listing_type_id'),
            'providerPracticeListings' => array(self::HAS_MANY, 'ProviderPracticeListing', 'listing_type_id'),
            'providerPracticeSocialEnhances' => array(self::HAS_MANY, 'ProviderPracticeSocialEnhance',
                'listing_type_id'),
            'site' => array(self::BELONGS_TO, 'Site', 'site_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'level' => Yii::t('app', 'Level'),
            'is_internal' => Yii::t('app', 'Is Internal'),
            'providerPracticeListings' => null,
            'code' => 'Code',
            'per' => 'Per',
            'logo_path' => 'Logo Path',
            'base_url' => 'Base Url',
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('level', $this->level, true);
        $criteria->compare('is_internal', $this->is_internal);
        $criteria->compare('code', $this->code, true);
        $criteria->compare('per', $this->per, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
